<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      style="height: 60vh;overflow: auto"
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      scroll-to-error
      v-loading="formLoading"
    >
      <el-form-item label="月嫂ID" prop="yuesaoId">
        <el-input v-model="formData.yuesaoId" disabled placeholder=""/>
      </el-form-item>
      <el-form-item label="月嫂姓名" prop="name">
        <el-input v-model="formData.name" :disabled="formType !== 'create'"
                  placeholder="请输入姓名"/>
      </el-form-item>
      <el-form-item label="注册手机号" prop="mobile">
        <el-input v-model="formData.mobile" placeholder="请输入注册手机号"/>
      </el-form-item>
      <el-form-item label="年龄" prop="age">
        <el-input v-model="formData.age" :disabled="formType !== 'create'"
                  placeholder="请输入年龄"/>
      </el-form-item>
      <el-form-item label="月嫂头像" prop="avatar">
        <UploadImg v-model="formData.avatar" height="120px" width="120px"/>
      </el-form-item>


      <el-form-item label="联系手机号" prop="mobileTel">
        <el-input v-model="formData.mobileTel" placeholder="请输入联系手机号"/>
      </el-form-item>
      <el-form-item label="微信号" prop="wechat">
        <el-input v-model="formData.wechat" placeholder="请输入联系微信号"/>
      </el-form-item>
      <el-form-item label="学历" prop="schoolDegree">
        <el-select
          v-model="formData.schoolDegree"
          clearable
          placeholder="请选择学历"
        >
          <el-option
            v-for="dict in dics.yuesao_schoolDegree"
            :key="dict.value"
            :label="dict.label"
            :value="Number(dict.value)"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="期望薪资" prop="expectedSalary">
        <el-input v-model="formData.expectedSalary" placeholder="请输入期望薪资">
          <template #suffix>/26天</template>
        </el-input>
      </el-form-item>

      <el-form-item label="籍贯" prop="origin">
        <el-select
          v-model="formData.origin"
          clearable
          placeholder="请选择籍贯"
        >
          <el-option
            v-for="dict in areas"
            :key="dict.id"
            :label="dict.name"
            :value="`${dict.id}`"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="子女数" prop="hasChildren">
        <el-input v-model="formData.hasChildren" placeholder="请输入子女数"/>
      </el-form-item>
      <el-form-item label="从业时长年" prop="workYear">
        <el-input v-model="formData.workYear" placeholder="请输入从业时长年">
          <template #suffix>年</template>
        </el-input>
      </el-form-item>
      <el-form-item label="民族" prop="nation">
        <el-select
          v-model="formData.nation"
          clearable
          placeholder="请选择民族"
        >
          <el-option
            v-for="dict in dics.yuesao_nation"
            :key="dict.value"
            :label="dict.label"
            :value="`${dict.value}`"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="自我介绍" prop="selfIntro">
        <el-input type="textarea" v-model="formData.selfIntro" placeholder="请输入自我介绍"/>
      </el-form-item>
      <el-form-item label="个人标签" prop="selfRemarks">
        <el-check-tag style="margin: 0 8px 8px 0" v-for="item in remarks" :key="item.id"
                      :checked="formData.remarksArray?.includes(item.id)"
                      type="primary"
                      @change="remarksChange($event, item)">
          {{ item.remark }}
        </el-check-tag>
      </el-form-item>
      <el-form-item label="月子餐照片" prop="yueZiCanUrls">
        <UploadImgs :limit="9" v-model="formData.yueZiCanUrls"/>
      </el-form-item>
      <el-form-item label="工作照片" prop="workUrls">
        <UploadImgs :limit="9" v-model="formData.workUrls"/>
      </el-form-item>
      <el-form-item label="评价照片" prop="evaluateUrls">
        <UploadImgs :limit="9" v-model="formData.evaluateUrls"/>
      </el-form-item>
      <el-form-item label="体检证明" prop="tijianUrls">
        <UploadImgs :limit="12" v-model="formData.tijianUrls"/>
      </el-form-item>

      <el-form-item label="头像分">
        <el-input-number v-model="formData.piont.avatarPoint" :step="1" :min="0" :max="10"
                         placeholder="请输入简历分"/>
      </el-form-item>
      <el-form-item label="简历分">
        <el-input-number v-model="formData.piont.selfInfoPoint" :step="1" :min="0" :max="15"
                         placeholder="请输入简历分"/>
      </el-form-item>
      <el-form-item label="活动分">
        <el-input-number v-model="formData.piont.offlineActPoint" :step="1" :min="0" :max="10"
                         placeholder="请输入活动分"/>
      </el-form-item>
      <el-form-item label="体检分">
        <el-input-number v-model="formData.piont.tijianPoint" :step="1" :min="0" :max="15"
                         placeholder="请输入体检分"/>
      </el-form-item>
      <el-form-item label="保险分">
        <el-input-number v-model="formData.piont.baoxianPoint" :step="1" :min="0" :max="15"
                         placeholder="请输入保险分"/>
      </el-form-item>
      <el-form-item label="培训分">
        <el-input-number v-model="formData.piont.trainPoint" :step="1" :min="0" :max="10"
                         placeholder="请输入培训分"/>
      </el-form-item>
      <el-form-item label="评价分">
        <el-input-number v-model="formData.piont.evaluatePoint" :step="1" :min="0" :max="10"
                         placeholder="请输入评价分"/>
      </el-form-item>
      <el-form-item label="体检更新时间" prop="tijianTime">
        <el-date-picker
          v-model="formData.tijianTime"
          type="date"
          value-format="x"
          placeholder="选择体检更新时间"
        />
      </el-form-item>
      <el-form-item label="是否背调" prop="isBeidiao">
        <el-select v-model="formData.isBeidiao">
          <el-option :value="true" label="是"></el-option>
          <el-option :value="false" label="否"/>
        </el-select>
      </el-form-item>
      <el-form-item label="背调时间" prop="beidiaoTime">
        <el-date-picker
          v-model="formData.beidiaoTime"
          type="date"
          value-format="x"
          placeholder="选择背调时间"
        />
      </el-form-item>
      <el-form-item label="保险时间" prop="baoxianTime">
        <el-date-picker
          v-model="formData.baoxianTime"
          type="date"
          value-format="x"
          placeholder="选择保险时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as ResumeApi from '@/api/yuesao/resume'
import {
  fetchRemarks,
  IAreaItem,
  IDicItem,
  IDicRes,
  IRemarkItem,
  ResumeVO
} from "@/api/yuesao/resume";
import {map, pick} from "lodash-es";


const {t} = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: '',
  yuesaoId: undefined,
  avatar: undefined,
  wechat: undefined,
  mobileTel: undefined,
  mobile: undefined,
  schoolDegree: undefined,
  workHistory: undefined,
  workSkill: undefined,
  expectedSalary: undefined,
  age: undefined,
  origin: undefined,
  hasChildren: undefined,
  workYear: undefined,
  nation: undefined,
  selfIntro: undefined,
  remarksArray: [],
  isBaoxian: undefined,
  isTijian: undefined,
  baoxianUrl: undefined,
  baoxianTime: undefined,
  tijianUrls: [],
  yueZiCanUrls: [],
  workUrls: [],
  evaluateUrls: [],
  baoxianUrls: [],
  tijianTime: undefined,
  isBeidiao: undefined,
  beidiaoTime: undefined,
  piont: {
    avatarPoint: 0,
    selfInfoPoint: 0,
    offlineActPoint: 0,
    tijianPoint: 0,
    baoxianPoint: 0,
    trainPoint: 0,
    evaluatePoint: 0,
  }
})
const formRules = reactive({
  name: [{required: true, message: '姓名必填'}],
  mobile: [{required: true, message: '手机号必填'}],
  mobileTel: [{required: true, message: '联系手机号必填'}],
  wechat: [{required: true, message: '微信号必填'}],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ResumeApi.getResume(id)
      formData.value.tijianUrls = encodeImages(formData.value.tijianUrls)
      formData.value.workUrls = encodeImages(formData.value.workUrls)
      formData.value.evaluateUrls = encodeImages(formData.value.evaluateUrls)
      formData.value.yueZiCanUrls = encodeImages(formData.value.yueZiCanUrls)
    } finally {
      formLoading.value = false
    }
  }
}

function encodeImages(arr: any[]): any[] {
  return arr.map((item, index) => {
    return {
      uid: `${item}_${index}`,
      url: item,
      status: ''
    }
  })
}

function decodeImages(arr: any[]): string[] {
  return map(arr, item => item.url)
}

defineExpose({open}) // 提供 open 方法，用于打开弹窗

const remarksChange = (flag, item) => {

  if (formData.value?.remarksArray?.length >= 3 && flag) {
    ElMessage.error('最多三个')
    return
  }
  if (flag) {
    formData.value?.remarksArray?.push(item.id)
  } else {
    const index = formData.value?.remarksArray.findIndex(i => i.id === item.id)
    console.log(formData.value?.remarksArray, index);

    formData.value?.remarksArray?.splice(index, 1)
  }
}

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const piont = formData.value.piont
    const baseFields = ['id', 'mobileTel', 'wechat', 'avatar', 'yuesaoId', 'schoolDegree', 'expectedSalary', 'origin', 'hasChildren', 'workYear',
      'nation', 'selfIntro', 'remarksArray', 'isBaoxian', 'isTijian', 'tijianUrls', 'workUrls', 'evaluateUrls',
      'yueZiCanUrls', 'baoxianUrls', 'tijianTime', 'baoxianTime']
    const createExtraFields = ['name', 'mobile']
    const data = pick(formData.value, formType.value === 'create' ? [...baseFields, ...createExtraFields] : baseFields) as unknown as ResumeVO
    //'beidiaoTime', 'isBeidiao'
    data.piont = {
      avatarPoint: piont.avatarPoint,
      selfInfoPoint: piont.selfInfoPoint,
      offlineActPoint: piont.offlineActPoint,
      tijianPoint: piont.tijianPoint,
      baoxianPoint: piont.baoxianPoint,
      trainPoint: piont.trainPoint,
      evaluatePoint: piont.evaluatePoint,
    }
    if (formType.value === 'create') {
      Object.assign(data, data.piont)
      delete data.piont
    }
    data.tijianUrls = decodeImages(data.tijianUrls)
    data.workUrls = decodeImages(data.workUrls)
    data.evaluateUrls = decodeImages(data.evaluateUrls)
    data.yueZiCanUrls = decodeImages(data.yueZiCanUrls)
    if (formType.value === 'create') {
      await ResumeApi.createResume(data)
      message.success(t('common.createSuccess'))
    } else {
      await ResumeApi.updateResume(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: '',
    yuesaoId: undefined,
    avatar: undefined,
    wechat: undefined,
    mobileTel: undefined,
    mobile: undefined,
    schoolDegree: undefined,
    workHistory: undefined,
    workSkill: undefined,
    expectedSalary: undefined,
    age: undefined,
    origin: undefined,
    hasChildren: undefined,
    workYear: undefined,
    nation: undefined,
    selfIntro: undefined,
    remarksArray: [],
    isBaoxian: undefined,
    isTijian: undefined,
    baoxianUrl: undefined,
    baoxianTime: undefined,
    tijianUrls: [],
    yueZiCanUrls: [],
    workUrls: [],
    evaluateUrls: [],
    baoxianUrls: [],
    tijianTime: undefined,
    isBeidiao: undefined,
    beidiaoTime: undefined,
    piont: {
      avatarPoint: 0,
      selfInfoPoint: 0,
      offlineActPoint: 0,
      tijianPoint: 0,
      baoxianPoint: 0,
      trainPoint: 0,
      evaluatePoint: 0,
    }
  }
  formRef.value?.resetFields()
}

const areas = ref<IAreaItem[]>([])
const dics = ref<IDicRes>({
  yuesao_nation: [], // 民族
  yuesao_schoolDegree: [] //  学历
})
const remarks = ref<IRemarkItem[]>([])

async function getAreas() {
  try {
    areas.value = await ResumeApi.fetchAreaTree()
  } catch {
    //
  }
}

async function getDics() {
  try {
    dics.value = await ResumeApi.fetchDics()
    console.log(dics.value, 3454);
  } catch {
    //
  }
}

async function getRemarks() {
  try {
    remarks.value = await ResumeApi.fetchRemarks()
  } catch {
    //
  }
}

getAreas()
getDics()
getRemarks()

</script>

<style lang="less" scoped>
.avatar-uploader .avatar {
  width: 120px;
  height: 120px;
  display: block;
}
</style>

<style>
.avatar-uploader .el-upload {
  border: 1px dashed var(--el-border-color);
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
  transition: var(--el-transition-duration-fast);
}

.avatar-uploader .el-upload:hover {
  border-color: var(--el-color-primary);
}

.el-icon.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  text-align: center;
}
</style>

